package org.ant.tasks;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.io.UnsupportedEncodingException;

import junit.framework.TestCase;

/**
 * A simple 'hello world' task unit test.
 */
public class HelloTaskTest extends TestCase {
	public void testExecute() throws UnsupportedEncodingException {
		PrintStream originalSystemOutput = System.out;		
		PrintStream taskOutput = null;
		
		try {
			ByteArrayOutputStream bufferStream = new ByteArrayOutputStream();
			taskOutput = new PrintStream(bufferStream, true, "UTF-8");
			
			System.setOut(taskOutput);
			
			HelloTask helloTask = new HelloTask();
			helloTask.execute();
			
			String helloString = "Hello World!" + System.getProperty("line.separator");
			assertTrue("'Hello World!' must be printed", areEqual(bufferStream.toByteArray(), helloString.getBytes("UTF-8")));			
		} finally {
			System.setOut(originalSystemOutput);
			
			if (taskOutput != null) {
				taskOutput.close();
			}
		}
	}
	
	private static boolean areEqual(byte[] first, byte[] second) {
		if (!(first.length == second.length)) {
			return false;
		}
		
		for (int i=0; i<first.length; ++i) {
			if (!(first[i] == second[i])) {
				return false;
			}
		}
		
		return true;
	}
}
